﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Hitager
{
    public class PortHandler
    {
        static SerialPort _serialPort;
        private string portName = "";

        public void setPort(string port)
        {
            portName = port;
        }

        private bool portOpen()
        {
            if (_serialPort == null)
                _serialPort = new SerialPort();
            if (!_serialPort.IsOpen)
            {
                _serialPort.BaudRate = 115200;
                _serialPort.PortName = portName;
                try
                {
                    _serialPort.Open();
                }
                catch(Exception e)
                {
                    MessageBox.Show(e.Message);
                    return false;
                }
                _serialPort.NewLine = "\n";
                _serialPort.ReadTimeout = 2000;
                byte[] tmpBuffer = new byte[1000];
                int available = _serialPort.BytesToRead;
                if (available>0)
                    _serialPort.Read(tmpBuffer, 0, available);

                _serialPort.DiscardInBuffer();
                _serialPort.DiscardOutBuffer();

                
            }
            return true;

        }

        TextBox debugTextBox;
        private void handleDebug(String text)
        {
            debugTextBox.AppendText(text + Environment.NewLine);
        }
        public void setDebug(ref TextBox textbox)
        {
            debugTextBox = textbox;
        }

        private void portClose()
        {
            _serialPort.Close();

        }

        public string portWR(String cmd)
        {

            String data = "";
            if (!portOpen())
                return "ERROR";
            for (int i = 0; i < 1; i++)
            {
                String received = "";
                _serialPort.Write(cmd);
                while (!received.Contains("EOF"))
                {
                    

                    try
                    {
                        received = _serialPort.ReadLine();
                    }
                    catch (Exception)
                    {
                        handleDebug("Please reset reader!");
                        portClose();
                        return ("TIMEOUT");
                    }
                    handleDebug(received);
                    if (received.Contains("RESP") && (!received.Contains("ERROR")))
                    {
                        data = received.Substring(5);
                        i = 5;

                    }
                    else if (received.Contains("RFON") || received.Contains("RFOFF"))
                    {
                        return "OK";
                    }
                }
            }
            portClose();

            return data;

        }
    }
}
