﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Hitager
{
    public partial class SerialDebugger : UserControl
    {
        public SerialDebugger()
        {
            InitializeComponent();
        }

        TextBox debugTextBox;
        private void handleDebug(String text)
        {
            debugTextBox.AppendText(text + Environment.NewLine);
        }
        public void setDebug(ref TextBox textbox)
        {
            debugTextBox = textbox;
        }

        private PortHandler portHandler;
        public void SetPortHandler(ref PortHandler handler)
        {
            portHandler = handler;
        }

        private void sendCommand(string command)
        {
            string binary = command;
            int left = command.Length % 4;
            if (left != 0)
            {
                for (int i = 0; i < 4 - left; i++)
                    binary += "0";
            }
            string hex = Convert.ToInt32(binary, 2).ToString("X");
            if (hex.Length % 2 != 0)
                hex += "0";
            string outcommand = "i" + command.Length.ToString("X2") + hex;
            portHandler.portWR(outcommand);
        }

        private string invert(string input)
        {
            string output = "";
            foreach (char c in input)
            {
                if (c == '1')
                    output += "0";
                else
                    output += "1";

            }
            return output;
        }



        private void bits1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!char.IsControl(e.KeyChar) && e.KeyChar!='1' && e.KeyChar != '0')
            {

                e.Handled = true;
            }
  
        }


        private void rfOn_Click(object sender, EventArgs e)
        {
            portHandler.portWR("o");
        }

        private void rfOff_Click(object sender, EventArgs e)
        {
            portHandler.portWR("f");
        }

        private void clear_Click(object sender, EventArgs e)
        {
            debugTextBox.Clear();
        }

        private void addInvert_Click(object sender, EventArgs e)
        {
            bits1.AppendText(invert(bits1.Text));
        }

        private void addInvert2_Click(object sender, EventArgs e)
        {
            bits2.AppendText(invert(bits2.Text));
        }

        private void addInvert3_Click(object sender, EventArgs e)
        {
            bits3.AppendText(invert(bits3.Text));
        }

        private void addInvert4_Click(object sender, EventArgs e)
        {
            bits4.AppendText(invert(bits4.Text));
        }

        private void addInvert5_Click(object sender, EventArgs e)
        {
            bits5.AppendText(invert(bits5.Text));
        }

        private void addInvert6_Click(object sender, EventArgs e)
        {
            bits6.AppendText(invert(bits6.Text));
        }

        private void addInvert7_Click(object sender, EventArgs e)
        {
            bits7.AppendText(invert(bits7.Text));
        }

        private void addInvert8_Click(object sender, EventArgs e)
        {
            bits8.AppendText(invert(bits8.Text));
        }


        private void send1_Click(object sender, EventArgs e)
        {
            sendCommand(bits1.Text);
        }

        private void send2_Click(object sender, EventArgs e)
        {
            sendCommand(bits2.Text);
        }

        private void send3_Click(object sender, EventArgs e)
        {
            sendCommand(bits3.Text);
        }

        private void send4_Click(object sender, EventArgs e)
        {
            sendCommand(bits4.Text);
        }

        private void send5_Click(object sender, EventArgs e)
        {
            sendCommand(bits5.Text);
        }

        private void send6_Click(object sender, EventArgs e)
        {
            sendCommand(bits6.Text);
        }

        private void send7_Click(object sender, EventArgs e)
        {
            sendCommand(bits7.Text);
        }

        private void send8_Click(object sender, EventArgs e)
        {
            sendCommand(bits8.Text);
        }
    }
}
